
set echo on

WITH ilv AS (
    SELECT str || ','                                   AS str
    ,     (LENGTH(str) - LENGTH(REPLACE(str, ','))) + 1 AS no_of_elements
    FROM   t
    )
SELECT RTRIM(str, ',')                              AS original_string
,      SUBSTR(str, start_pos, (next_pos-start_pos)) AS single_element
,      element_no
FROM  (
       SELECT ilv.str
       ,      nt.column_value AS element_no
       ,      INSTR(
                 ilv.str,
                 ',',
                 DECODE(nt.column_value, 1, 0, 1),
                 DECODE(nt.column_value, 1, 1, nt.column_value-1)) + 1 AS start_pos
       ,      INSTR(
                 ilv.str,
                 ',',
                 1,
                 DECODE(nt.column_value, 1, 1, nt.column_value)) AS next_pos
       FROM   ilv
       ,      TABLE(
                 CAST(
                    MULTISET(
                       SELECT ROWNUM FROM dual CONNECT BY ROWNUM < ilv.no_of_elements
                       ) AS number_ntt )) nt
      );

