
set echo on

col element_count noprint

WITH ilv AS (
   SELECT str                                          AS orig_str
   ,      ',' || str || ','                            AS mod_str
   ,      1                                            AS start_pos
   ,      LENGTH(str)                                  AS end_pos
   ,     (LENGTH(str) - LENGTH(REPLACE(str, ','))) + 1 AS element_count
   ,      0                                            AS element_no
   ,      ROWNUM                                       AS rn
   FROM   t
   )
SELECT orig_str AS original_string
,      SUBSTR(mod_str, start_pos, end_pos-start_pos) AS single_element
,      element_no
,      element_count
FROM  (
       SELECT *
       FROM   ilv
       MODEL
           PARTITION BY (rn, orig_str, mod_str)
           DIMENSION BY (element_no)
           MEASURES     (start_pos, end_pos, element_count)
           RULES
               ITERATE (2000)
               UNTIL (ITERATION_NUMBER+1 = element_count[0])
               (
                 start_pos[ITERATION_NUMBER+1] 
                    = INSTR(CV(mod_str), ',', 1, CV(element_no)) + 1,
                 end_pos[ITERATION_NUMBER+1] 
                    = INSTR(CV(mod_str), ',', 1, CV(element_no) + 1)
               )
      )
WHERE  element_no != 0
ORDER  BY
       mod_str
,      element_no;

